# Uses of Interface
org.bukkit.block.Block

Packages that use Block
Package
Description
com.destroystokyo.paper
com.destroystokyo.paper.block
com.destroystokyo.paper.event.block
com.destroystokyo.paper.loottable
io.papermc.paper.event.block
io.papermc.paper.event.entity
io.papermc.paper.event.player
org.bukkit
The root package of the Bukkit API, contains generalized API classes.
org.bukkit.block
Classes used to manipulate the voxels in a `world`, including special states.
org.bukkit.block.data
Generalized BlockData classes.
org.bukkit.command
Classes relating to handling specialized non-chat player input.
org.bukkit.entity
Interfaces for non-voxel objects that can exist in a `world`, including all players, monsters, projectiles, etc.
org.bukkit.event.block
`Events` relating to when a `block` is changed or interacts with the `world`.
org.bukkit.event.enchantment
`Events` triggered from an `enchantment table`.
org.bukkit.event.entity
`Events` relating to `entities`, excluding some directly referencing some more specific entity types.
org.bukkit.event.hanging
`Events` relating to `entities that hang`.
org.bukkit.event.inventory
`Events` relating to `inventory` manipulation.
org.bukkit.event.player
`Events` relating to `players`.
org.bukkit.event.vehicle
`Events` relating to `vehicular entities`.
org.bukkit.inventory
Classes involved in manipulating player inventories and item interactions.
org.bukkit.projectiles
Classes to represent the source of a projectile
org.bukkit.util
Multi and single purpose classes to facilitate various programmatic concepts.

## Uses of Block in com.destroystokyo.paper

Methods in com.destroystokyo.paper with parameters of type Block
Modifier and Type
Method
Description
`boolean`
MaterialSetTag.`isTagged(@NotNull Block block)`

## Uses of Block in com.destroystokyo.paper.block

Methods in com.destroystokyo.paper.block that return Block
Modifier and Type
Method
Description
`@NotNull Block`
TargetBlockInfo.`getBlock()`
Get the block that is targeted
`@NotNull Block`
TargetBlockInfo.`getRelativeBlock()`
Get the relative Block to the targeted block on the side it is targeted at
Constructors in com.destroystokyo.paper.block with parameters of type Block
Modifier
Constructor
Description
``
`TargetBlockInfo(@NotNull Block block, @NotNull BlockFace blockFace)`

## Uses of Block in com.destroystokyo.paper.event.block

Constructors in com.destroystokyo.paper.event.block with parameters of type Block
Modifier
Constructor
Description
``
`BeaconEffectEvent(@NotNull Block block, @NotNull PotionEffect effect, @NotNull Player player, boolean primary)`
``
`BlockDestroyEvent(@NotNull Block block, @NotNull BlockData newState, boolean willDrop)`
``
`TNTPrimeEvent(@NotNull Block theBlock, @NotNull TNTPrimeEvent.PrimeReason reason, @Nullable Entity primerEntity)`

## Uses of Block in com.destroystokyo.paper.loottable

Methods in com.destroystokyo.paper.loottable that return Block
Modifier and Type
Method
Description
`@NotNull Block`
LootableBlockInventory.`getBlock()`
Gets the block that is lootable

## Uses of Block in io.papermc.paper.event.block

Methods in io.papermc.paper.event.block that return Block
Modifier and Type
Method
Description
`@NotNull Block`
PlayerShearBlockEvent.`getBlock()`
Gets the block being sheared in this event.
`@NotNull Block`
BlockBreakBlockEvent.`getSource()`
Gets the block that cause this (e.g.
Constructors in io.papermc.paper.event.block with parameters of type Block
Modifier
Constructor
Description
``
`BeaconActivatedEvent(@NotNull Block block)`
``
`BeaconDeactivatedEvent(@NotNull Block block)`
``
`BellRevealRaiderEvent(@NotNull Block theBlock, @NotNull Entity raider)`
``
`BellRingEvent(@NotNull Block block, @Nullable Entity entity)`
``
`BlockBreakBlockEvent(@NotNull Block block, @NotNull Block source, @NotNull List<ItemStack> drops)`
``
`BlockFailedDispenseEvent(@NotNull Block theBlock)`
``
`BlockPreDispenseEvent(@NotNull Block block, @NotNull ItemStack itemStack, int slot)`
``
`DragonEggFormEvent(@NotNull Block block, @NotNull BlockState newState, @NotNull DragonBattle dragonBattle)`
``
`PlayerShearBlockEvent(@NotNull Player who, @NotNull Block block, @NotNull ItemStack item, @NotNull EquipmentSlot hand, @NotNull List<ItemStack> drops)`
``
`TargetHitEvent(@NotNull Projectile projectile, @NotNull Block block, @NotNull BlockFace blockFace, int signalStrength)`

## Uses of Block in io.papermc.paper.event.entity

Methods in io.papermc.paper.event.entity that return Block
Modifier and Type
Method
Description
`@NotNull Block`
EntityInsideBlockEvent.`getBlock()`
Gets the block.
Constructors in io.papermc.paper.event.entity with parameters of type Block
Modifier
Constructor
Description
``
`EntityInsideBlockEvent(@NotNull Entity entity, @NotNull Block block)`

## Uses of Block in io.papermc.paper.event.player

Methods in io.papermc.paper.event.player that return Block
Modifier and Type
Method
Description
`@Nullable Block`
PlayerChangeBeaconEffectEvent.`getBeacon()`
`@NotNull Block`
PlayerBedFailEnterEvent.`getBed()`
`@NotNull Block`
PlayerFlowerPotManipulateEvent.`getFlowerpot()`
Gets the flowerpot that is involved in this event.
Constructors in io.papermc.paper.event.player with parameters of type Block
Modifier
Constructor
Description
``
`PlayerBedFailEnterEvent(@NotNull Player player, @NotNull PlayerBedFailEnterEvent.FailReason failReason, @NotNull Block bed, boolean willExplode, @Nullable Component message)`
``
`PlayerChangeBeaconEffectEvent(@NotNull Player player, @Nullable PotionEffectType primary, @Nullable PotionEffectType secondary, @Nullable Block beacon)`
``
`PlayerFlowerPotManipulateEvent(@NotNull Player player, @NotNull Block flowerpot, @NotNull ItemStack item, boolean placing)`

## Uses of Block in org.bukkit

Methods in org.bukkit that return Block
Modifier and Type
Method
Description
`@NotNull Block`
Chunk.`getBlock(int x, int y, int z)`
Gets a block from this chunk
`@NotNull Block`
Location.`getBlock()`
Gets the block at the represented location
`@NotNull Block`
Vibration.Destination.BlockDestination.`getBlock()`
`@NotNull Block`
World.`getBlockAt(int x, int y, int z)`
Gets the `Block` at the given coordinates
`@NotNull Block`
World.`getBlockAt(@NotNull Location location)`
Gets the `Block` at the given `Location`
`default @NotNull Block`
World.`getBlockAtKey(long key)`
Deprecated.
only encodes y block ranges from -512 to 511 and represents an already changed implementation detail
`@NotNull Block`
World.`getHighestBlockAt(int x, int z)`
Gets the highest non-empty (impassable) block at the given coordinates.
`@NotNull Block`
World.`getHighestBlockAt(int x, int z, @NotNull HeightMap heightMap)`
Gets the highest block corresponding to the `HeightMap` at the given coordinates.
`default @NotNull Block`
World.`getHighestBlockAt(int x, int z, HeightmapType heightmap)`
Deprecated.
Upstream has added support for this, use `World.getHighestBlockAt(int, int, HeightMap)`
`@NotNull Block`
World.`getHighestBlockAt(@NotNull Location location)`
Gets the highest non-empty (impassable) block at the given coordinates.
`@NotNull Block`
World.`getHighestBlockAt(@NotNull Location location, @NotNull HeightMap heightMap)`
Gets the highest block corresponding to the `HeightMap` at the given coordinates.
`default @NotNull Block`
World.`getHighestBlockAt(@NotNull Location location, HeightmapType heightmap)`
Deprecated.
Upstream has added support for this, use `World.getHighestBlockAt(Location, HeightMap)`
Methods in org.bukkit with parameters of type Block
Modifier and Type
Method
Description
`@NotNull Chunk`
World.`getChunkAt(@NotNull Block block)`
Gets the `Chunk` that contains the given `Block`
`default CompletableFuture<Chunk>`
World.`getChunkAtAsync(@NotNull Block block)`
Requests a `Chunk` to be loaded at the given coordinates This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`default CompletableFuture<Chunk>`
World.`getChunkAtAsync(@NotNull Block block, boolean gen)`
Requests a `Chunk` to be loaded at the given coordinates This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`default void`
World.`getChunkAtAsync(@NotNull Block block, boolean gen, Consumer<Chunk> cb)`
Requests `Chunk` to be loaded that contains the given `Block` This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`default void`
World.`getChunkAtAsync(@NotNull Block block, @NotNull World.ChunkLoadCallback cb)`
Deprecated.
Use either the Future or the Consumer based methods
`default void`
World.`getChunkAtAsync(@NotNull Block block, Consumer<Chunk> cb)`
Requests `Chunk` to be loaded that contains the given `Block` This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`default CompletableFuture<Chunk>`
World.`getChunkAtAsyncUrgently(@NotNull Block block)`
Requests a `Chunk` to be loaded at the given coordinates This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`default CompletableFuture<Chunk>`
World.`getChunkAtAsyncUrgently(@NotNull Block block, boolean gen)`
Requests a `Chunk` to be loaded at the given coordinates This method makes no guarantee on how fast the chunk will load, and will return the chunk to the callback at a later time.
`String`
UnsafeValues.`getTranslationKey(Block block)`
Deprecated.
Return the translation key for the Block, so the client can translate it into the active locale when using a `TranslatableComponent`.
Method parameters in org.bukkit with type arguments of type Block
Modifier and Type
Method
Description
`@NotNull Collection<BlockState>`
Chunk.`getTileEntities(@NotNull Predicate<Block> blockPredicate, boolean useSnapshot)`
Get a list of all tile entities that match a given predicate in the chunk.
Constructors in org.bukkit with parameters of type Block
Modifier
Constructor
Description
``
`BlockDestination(@NotNull Block block)`

## Uses of Block in org.bukkit.block

Methods in org.bukkit.block that return Block
Modifier and Type
Method
Description
`@NotNull Block`
BlockState.`getBlock()`
Gets the block represented by this block state.
`@NotNull Block`
Block.`getRelative(int modX, int modY, int modZ)`
Gets the block at the given offsets
`@NotNull Block`
Block.`getRelative(@NotNull BlockFace face)`
Gets the block at the given face
`@NotNull Block`
Block.`getRelative(@NotNull BlockFace face, int distance)`
Gets the block at the given distance of the given face
Methods in org.bukkit.block with parameters of type Block
Modifier and Type
Method
Description
`@Nullable BlockFace`
Block.`getFace(@NotNull Block block)`
Gets the face relation of this block compared to the given block.

## Uses of Block in org.bukkit.block.data

Methods in org.bukkit.block.data with parameters of type Block
Modifier and Type
Method
Description
`boolean`
BlockData.`isSupported(@NotNull Block block)`
Checks if this state would be properly supported if it were placed at the given `Block`.

## Uses of Block in org.bukkit.command

Methods in org.bukkit.command that return Block
Modifier and Type
Method
Description
`@NotNull Block`
BlockCommandSender.`getBlock()`
Returns the block this command sender belongs to

## Uses of Block in org.bukkit.entity

Methods in org.bukkit.entity that return Block
Modifier and Type
Method
Description
`@Nullable Block`
AbstractArrow.`getAttachedBlock()`
Gets the block to which this arrow is attached.
`@Nullable Block`
Raider.`getPatrolTarget()`
Gets the block the raider is targeting to patrol.
`default @Nullable Block`
LivingEntity.`getTargetBlock(int maxDistance)`
Gets the block that the living entity has targeted, ignoring fluids
`@Nullable Block`
LivingEntity.`getTargetBlock(int maxDistance, TargetBlockInfo.FluidMode fluidMode)`
Gets the block that the living entity has targeted
`@NotNull Block`
LivingEntity.`getTargetBlock(@Nullable Set<Material> transparent, int maxDistance)`
Gets the block that the living entity has targeted.
`@Nullable Block`
LivingEntity.`getTargetBlockExact(int maxDistance)`
Gets the block that the living entity has targeted.
`@Nullable Block`
LivingEntity.`getTargetBlockExact(int maxDistance, @NotNull FluidCollisionMode fluidCollisionMode)`
Gets the block that the living entity has targeted.
Methods in org.bukkit.entity that return types with arguments of type Block
Modifier and Type
Method
Description
`@NotNull List<Block>`
LivingEntity.`getLastTwoTargetBlocks(@Nullable Set<Material> transparent, int maxDistance)`
Gets the last two blocks along the living entity's line of sight.
`@NotNull List<Block>`
LivingEntity.`getLineOfSight(@Nullable Set<Material> transparent, int maxDistance)`
Gets all blocks along the living entity's line of sight.
Methods in org.bukkit.entity with parameters of type Block
Modifier and Type
Method
Description
`boolean`
Player.`breakBlock(@NotNull Block block)`
Force this player to break a Block using the item in their main hand.
`void`
Raider.`setPatrolTarget(@Nullable Block block)`
Sets the block the raider is targeting to patrol.

## Uses of Block in org.bukkit.event.block

Fields in org.bukkit.event.block declared as Block
Modifier and Type
Field
Description
`protected Block`
BlockEvent.`block`
`protected Block`
BlockPlaceEvent.`placedAgainst`
`protected Block`
BlockFromToEvent.`to`
Methods in org.bukkit.event.block that return Block
Modifier and Type
Method
Description
`final @NotNull Block`
BlockEvent.`getBlock()`
Gets the block involved in this event.
`@NotNull Block`
BlockPlaceEvent.`getBlockAgainst()`
Gets the block that this block was placed against
`@NotNull Block`
BlockPlaceEvent.`getBlockPlaced()`
Clarity method for getting the placed block.
`@Nullable Block`
BlockBurnEvent.`getIgnitingBlock()`
Gets the block which ignited this block.
`@Nullable Block`
BlockIgniteEvent.`getIgnitingBlock()`
Gets the block which ignited this block
`@NotNull Block`
BlockSpreadEvent.`getSource()`
Gets the source block involved in this event.
`@NotNull Block`
BlockPhysicsEvent.`getSourceBlock()`
Gets the source block that triggered this event.
`@NotNull Block`
BlockFromToEvent.`getToBlock()`
Convenience method for getting the faced Block.
Methods in org.bukkit.event.block that return types with arguments of type Block
Modifier and Type
Method
Description
`@NotNull List<Block>`
BlockExplodeEvent.`blockList()`
Returns the list of blocks that would have been removed or were removed from the explosion event.
`@NotNull List<Block>`
BlockPistonExtendEvent.`getBlocks()`
Get an immutable list of the blocks which will be moved by the extending.
`@NotNull List<Block>`
BlockPistonRetractEvent.`getBlocks()`
Get an immutable list of the blocks which will be moved by the extending.
Constructors in org.bukkit.event.block with parameters of type Block
Modifier
Constructor
Description
``
`BlockBreakEvent(@NotNull Block theBlock, @NotNull Player player)`
``
`BlockBurnEvent(@NotNull Block block)`
Deprecated.
``
`BlockBurnEvent(@NotNull Block block, @Nullable Block ignitingBlock)`
``
`BlockCanBuildEvent(@NotNull Block block, @NotNull BlockData type, boolean canBuild)`
Deprecated.
``
`BlockCanBuildEvent(@NotNull Block block, @Nullable Player player, @NotNull BlockData type, boolean canBuild)`
``
`BlockCookEvent(@NotNull Block block, @NotNull ItemStack source, @NotNull ItemStack result)`
Deprecated.
``
`BlockCookEvent(@NotNull Block block, @NotNull ItemStack source, @NotNull ItemStack result, CookingRecipe<?> recipe)`
``
`BlockDamageAbortEvent(@NotNull Player player, @NotNull Block block, @NotNull ItemStack itemInHand)`
``
`BlockDamageEvent(@NotNull Player player, @NotNull Block block, @NotNull ItemStack itemInHand, boolean instaBreak)`
``
`BlockDispenseArmorEvent(@NotNull Block block, @NotNull ItemStack dispensed, @NotNull LivingEntity target)`
``
`BlockDispenseEvent(@NotNull Block block, @NotNull ItemStack dispensed, @NotNull Vector velocity)`
``
`BlockDropItemEvent(@NotNull Block block, @NotNull BlockState blockState, @NotNull Player player, @NotNull List<Item> items)`
``
`BlockEvent(@NotNull Block theBlock)`
``
`BlockExpEvent(@NotNull Block block, int exp)`
``
`BlockExplodeEvent(@NotNull Block what, @NotNull List<Block> blocks, float yield)`
``
`BlockFadeEvent(@NotNull Block block, @NotNull BlockState newState)`
``
`BlockFertilizeEvent(@NotNull Block theBlock, @Nullable Player player, @NotNull List<BlockState> blocks)`
``
`BlockFormEvent(@NotNull Block block, @NotNull BlockState newState)`
``
`BlockFromToEvent(@NotNull Block block, @NotNull Block toBlock)`
``
`BlockFromToEvent(@NotNull Block block, @NotNull BlockFace face)`
``
`BlockGrowEvent(@NotNull Block block, @NotNull BlockState newState)`
``
`BlockIgniteEvent(@NotNull Block theBlock, @NotNull BlockIgniteEvent.IgniteCause cause, @NotNull Block ignitingBlock)`
``
`BlockIgniteEvent(@NotNull Block theBlock, @NotNull BlockIgniteEvent.IgniteCause cause, @Nullable Entity ignitingEntity)`
``
`BlockIgniteEvent(@NotNull Block theBlock, @NotNull BlockIgniteEvent.IgniteCause cause, @Nullable Entity ignitingEntity, @Nullable Block ignitingBlock)`
``
`BlockMultiPlaceEvent(@NotNull List<BlockState> states, @NotNull Block clicked, @NotNull ItemStack itemInHand, @NotNull Player thePlayer, boolean canBuild)`
Deprecated.
``
`BlockMultiPlaceEvent(@NotNull List<BlockState> states, @NotNull Block clicked, @NotNull ItemStack itemInHand, @NotNull Player thePlayer, boolean canBuild, EquipmentSlot hand)`
``
`BlockPhysicsEvent(@NotNull Block block, @NotNull BlockData changed)`
``
`BlockPhysicsEvent(@NotNull Block block, @NotNull BlockData changed, @NotNull Block sourceBlock)`
``
`BlockPhysicsEvent(Block block, BlockData changed, int sourceX, int sourceY, int sourceZ)`
Deprecated.
``
`BlockPistonEvent(@NotNull Block block, @NotNull BlockFace direction)`
``
`BlockPistonExtendEvent(@NotNull Block block, int length, @NotNull BlockFace direction)`
Deprecated.
``
`BlockPistonExtendEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`
``
`BlockPistonRetractEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`
``
`BlockPlaceEvent(@NotNull Block placedBlock, @NotNull BlockState replacedBlockState, @NotNull Block placedAgainst, @NotNull ItemStack itemInHand, @NotNull Player thePlayer, boolean canBuild)`
Deprecated.
``
`BlockPlaceEvent(@NotNull Block placedBlock, @NotNull BlockState replacedBlockState, @NotNull Block placedAgainst, @NotNull ItemStack itemInHand, @NotNull Player thePlayer, boolean canBuild, @NotNull EquipmentSlot hand)`
``
`BlockReceiveGameEvent(@NotNull GameEvent event, @NotNull Block block, @Nullable Entity entity)`
``
`BlockRedstoneEvent(@NotNull Block block, int oldCurrent, int newCurrent)`
``
`BlockShearEntityEvent(@NotNull Block dispenser, @NotNull Entity sheared, @NotNull ItemStack tool)`
``
`BlockSpreadEvent(@NotNull Block block, @NotNull Block source, @NotNull BlockState newState)`
``
`CauldronLevelChangeEvent(@NotNull Block block, @Nullable Entity entity, @NotNull CauldronLevelChangeEvent.ChangeReason reason, @NotNull BlockState newBlock)`
``
`EntityBlockFormEvent(@NotNull Entity entity, @NotNull Block block, @NotNull BlockState blockstate)`
``
`FluidLevelChangeEvent(@NotNull Block theBlock, @NotNull BlockData newData)`
``
`LeavesDecayEvent(@NotNull Block block)`
``
`MoistureChangeEvent(@NotNull Block block, @NotNull BlockState newState)`
``
`NotePlayEvent(@NotNull Block block, @NotNull Instrument instrument, @NotNull Note note)`
``
`SignChangeEvent(@NotNull Block theBlock, @NotNull Player thePlayer, @NotNull String[] theLines)`
Deprecated.
``
`SignChangeEvent(@NotNull Block theBlock, @NotNull Player player, List<Component> adventure$lines)`
``
`SpongeAbsorbEvent(@NotNull Block block, @NotNull List<BlockState> waterblocks)`
Constructor parameters in org.bukkit.event.block with type arguments of type Block
Modifier
Constructor
Description
``
`BlockExplodeEvent(@NotNull Block what, @NotNull List<Block> blocks, float yield)`
``
`BlockPistonExtendEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`
``
`BlockPistonRetractEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`

## Uses of Block in org.bukkit.event.enchantment

Methods in org.bukkit.event.enchantment that return Block
Modifier and Type
Method
Description
`@NotNull Block`
EnchantItemEvent.`getEnchantBlock()`
Gets the block being used to enchant the item
`@NotNull Block`
PrepareItemEnchantEvent.`getEnchantBlock()`
Gets the block being used to enchant the item
Constructors in org.bukkit.event.enchantment with parameters of type Block
Modifier
Constructor
Description
``
`EnchantItemEvent(@NotNull Player enchanter, @NotNull InventoryView view, @NotNull Block table, @NotNull ItemStack item, int level, @NotNull Map<Enchantment,Integer> enchants, int i)`
``
`PrepareItemEnchantEvent(@NotNull Player enchanter, @NotNull InventoryView view, @NotNull Block table, @NotNull ItemStack item, @Nullable EnchantmentOffer @NotNull [] offers, int bonus)`

## Uses of Block in org.bukkit.event.entity

Fields in org.bukkit.event.entity declared as Block
Modifier and Type
Field
Description
`protected Block`
EntityInteractEvent.`block`
Methods in org.bukkit.event.entity that return Block
Modifier and Type
Method
Description
`@NotNull Block`
EntityChangeBlockEvent.`getBlock()`
Gets the block the entity is changing
`@NotNull Block`
EntityEnterBlockEvent.`getBlock()`
Get the block the entity will enter.
`@NotNull Block`
EntityInteractEvent.`getBlock()`
Returns the involved block
`@NotNull Block`
EntityPlaceEvent.`getBlock()`
Returns the block that the entity was placed on
`@Nullable Block`
EntityCombustByBlockEvent.`getCombuster()`
The combuster can be lava or a block that is on fire.
`@Nullable Block`
EntityDamageByBlockEvent.`getDamager()`
Returns the block that damaged the player.
`@Nullable Block`
ProjectileHitEvent.`getHitBlock()`
Gets the block that was hit, if it was a block that was hit.
Methods in org.bukkit.event.entity that return types with arguments of type Block
Modifier and Type
Method
Description
`@NotNull List<Block>`
EntityExplodeEvent.`blockList()`
Returns the list of blocks that would have been removed or were removed from the explosion event.
Constructors in org.bukkit.event.entity with parameters of type Block
Modifier
Constructor
Description
``
`EntityBreakDoorEvent(@NotNull LivingEntity entity, @NotNull Block targetBlock)`
``
`EntityChangeBlockEvent(@NotNull Entity what, @NotNull Block block, @NotNull BlockData to)`
``
`EntityCombustByBlockEvent(@Nullable Block combuster, @NotNull Entity combustee, int duration)`
``
`EntityDamageByBlockEvent(@Nullable Block damager, @NotNull Entity damagee, @NotNull EntityDamageEvent.DamageCause cause, double damage)`
``
`EntityDamageByBlockEvent(@Nullable Block damager, @NotNull Entity damagee, @NotNull EntityDamageEvent.DamageCause cause, @NotNull Map<EntityDamageEvent.DamageModifier,Double> modifiers, @NotNull Map<EntityDamageEvent.DamageModifier,? extends Function<? super Double,Double>> modifierFunctions)`
``
`EntityEnterBlockEvent(@NotNull Entity entity, @NotNull Block block)`
``
`EntityInteractEvent(@NotNull Entity entity, @NotNull Block block)`
``
`EntityPlaceEvent(@NotNull Entity entity, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace)`
Deprecated.
``
`EntityPlaceEvent(@NotNull Entity entity, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @NotNull EquipmentSlot hand)`
``
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Block hitBlock)`
``
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity, @Nullable Block hitBlock)`
``
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity, @Nullable Block hitBlock, @Nullable BlockFace hitFace)`
Constructor parameters in org.bukkit.event.entity with type arguments of type Block
Modifier
Constructor
Description
``
`EntityExplodeEvent(@NotNull Entity what, @NotNull Location location, @NotNull List<Block> blocks, float yield)`

## Uses of Block in org.bukkit.event.hanging

Methods in org.bukkit.event.hanging that return Block
Modifier and Type
Method
Description
`@NotNull Block`
HangingPlaceEvent.`getBlock()`
Returns the block that the hanging entity was placed on
Constructors in org.bukkit.event.hanging with parameters of type Block
Modifier
Constructor
Description
``
`HangingPlaceEvent(@NotNull Hanging hanging, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @Nullable EquipmentSlot hand)`
Deprecated.
``
`HangingPlaceEvent(@NotNull Hanging hanging, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @Nullable EquipmentSlot hand, @Nullable ItemStack itemStack)`

## Uses of Block in org.bukkit.event.inventory

Constructors in org.bukkit.event.inventory with parameters of type Block
Modifier
Constructor
Description
``
`BrewEvent(@NotNull Block brewer, @NotNull BrewerInventory contents, @NotNull List<ItemStack> results, int fuelLevel)`
``
`BrewingStandFuelEvent(@NotNull Block brewingStand, @NotNull ItemStack fuel, int fuelPower)`
``
`FurnaceBurnEvent(@NotNull Block furnace, @NotNull ItemStack fuel, int burnTime)`
``
`FurnaceExtractEvent(@NotNull Player player, @NotNull Block block, @NotNull Material itemType, int itemAmount, int exp)`
``
`FurnaceSmeltEvent(@NotNull Block furnace, @NotNull ItemStack source, @NotNull ItemStack result)`
Deprecated.
``
`FurnaceSmeltEvent(@NotNull Block furnace, @NotNull ItemStack source, @NotNull ItemStack result, CookingRecipe<?> recipe)`
``
`FurnaceStartSmeltEvent(@NotNull Block furnace, @NotNull ItemStack source, @NotNull CookingRecipe<?> recipe)`
Deprecated.
``
`FurnaceStartSmeltEvent(@NotNull Block furnace, @NotNull ItemStack source, @NotNull CookingRecipe<?> recipe, int cookingTime)`

## Uses of Block in org.bukkit.event.player

Fields in org.bukkit.event.player declared as Block
Modifier and Type
Field
Description
`protected Block`
PlayerInteractEvent.`blockClicked`
Methods in org.bukkit.event.player that return Block
Modifier and Type
Method
Description
`@NotNull Block`
PlayerBedEnterEvent.`getBed()`
Returns the bed block involved in this event.
`@NotNull Block`
PlayerBedLeaveEvent.`getBed()`
Returns the bed block involved in this event.
`final @NotNull Block`
PlayerBucketEvent.`getBlock()`
Gets the block involved in this event.
`@NotNull Block`
PlayerBucketEvent.`getBlockClicked()`
Return the block clicked
`@Nullable Block`
PlayerInteractEvent.`getClickedBlock()`
Returns the clicked block
`@NotNull Block`
PlayerHarvestBlockEvent.`getHarvestedBlock()`
Gets the block that is being harvested.
Constructors in org.bukkit.event.player with parameters of type Block
Modifier
Constructor
Description
``
`PlayerBedEnterEvent(@NotNull Player who, @NotNull Block bed)`
Deprecated.
``
`PlayerBedEnterEvent(@NotNull Player who, @NotNull Block bed, @NotNull PlayerBedEnterEvent.BedEnterResult bedEnterResult)`
``
`PlayerBedLeaveEvent(@NotNull Player who, @NotNull Block bed, boolean setBedSpawn)`
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerHarvestBlockEvent(@NotNull Player player, @NotNull Block harvestedBlock, @NotNull List<ItemStack> itemsHarvested)`
Deprecated.
``
`PlayerHarvestBlockEvent(@NotNull Player player, @NotNull Block harvestedBlock, @NotNull EquipmentSlot hand, @NotNull List<ItemStack> itemsHarvested)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace, @Nullable EquipmentSlot hand)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace, @Nullable EquipmentSlot hand, @Nullable Location interactionPoint)`

## Uses of Block in org.bukkit.event.vehicle

Methods in org.bukkit.event.vehicle that return Block
Modifier and Type
Method
Description
`@NotNull Block`
VehicleBlockCollisionEvent.`getBlock()`
Gets the block the vehicle collided with
Constructors in org.bukkit.event.vehicle with parameters of type Block
Modifier
Constructor
Description
``
`VehicleBlockCollisionEvent(@NotNull Vehicle vehicle, @NotNull Block block)`

## Uses of Block in org.bukkit.inventory

Methods in org.bukkit.inventory that return Block
Modifier and Type
Method
Description
`@NotNull Block`
BlockInventoryHolder.`getBlock()`
Gets the block associated with this holder.

## Uses of Block in org.bukkit.projectiles

Methods in org.bukkit.projectiles that return Block
Modifier and Type
Method
Description
`@NotNull Block`
BlockProjectileSource.`getBlock()`
Gets the block this projectile source belongs to.

## Uses of Block in org.bukkit.util

Methods in org.bukkit.util that return Block
Modifier and Type
Method
Description
`@Nullable Block`
RayTraceResult.`getHitBlock()`
Gets the hit block.
`@NotNull Block`
BlockIterator.`next()`
Returns the next Block in the trace
Methods in org.bukkit.util with parameters of type Block
Modifier and Type
Method
Description
`static @NotNull BoundingBox`
BoundingBox.`of(@NotNull Block block)`
Creates a new 1x1x1 sized bounding box containing the given block.
`static @NotNull BoundingBox`
BoundingBox.`of(@NotNull Block corner1, @NotNull Block corner2)`
Creates a new bounding box using the coordinates of the given blocks as corners.
Constructors in org.bukkit.util with parameters of type Block
Modifier
Constructor
Description
``
`RayTraceResult(@NotNull Vector hitPosition, @Nullable Block hitBlock, @Nullable BlockFace hitBlockFace)`
Creates a RayTraceResult.